/*
 * @author laurin
 * @date 16.08.2005
 * @version $Id: SimpleTemplateExample.java,v 1.4 2009-12-16 16:12:02 herbert Exp $
 */
package com.gentics.portalnode.sdk;

import java.io.IOException;
import java.util.Date;

import javax.portlet.PortletException;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;

import com.gentics.api.portalnode.portlet.AbstractGenticsPortlet;
import com.gentics.api.portalnode.portlet.GenticsPortletContext;
import com.gentics.api.portalnode.templateengine.TemplateProcessor;

/**
 * @author laurin
 */
public class SimpleTemplateExample extends AbstractGenticsPortlet {

    public SimpleTemplateExample(String moduleId) throws PortletException {
        super(moduleId);
    }

    protected void doView(RenderRequest request, RenderResponse response)
            throws PortletException, IOException {
        // fetch a template processor from the portal
        GenticsPortletContext ctx = getGenticsPortletContext();
        TemplateProcessor templateProcessor  = ctx.getTemplateProcessor(this, getPortletConfig());
        
        try {
            // store some sample content into the template. the dateFormatter
            // may be used to format the date nicely.
            templateProcessor.put("now", new Date());
            // print the output to the response.
            response.getWriter().print(templateProcessor.getOutput("main", this));
        } catch (Exception ex) {
            logger.error("template error", ex);
        }
        returnTemplateProcessor(templateProcessor);
    }

}
