GENTICS.DragDrop = {};

/**
 * initialize all drag/drop handlers
 * sortables: an array describing all positions that are draggable
 *     .position: the id of the position
 *     .id: the id of the dom element
 *     .accept: css class
 *     .connectWith: array of other sortables
 *     .helperclass: css class of ghost drop target
 *     .handle: selector of drag handle
 */
GENTICS.DragDrop.create = function(sortables, url) {
	if (sortables) {
		this.sortables = sortables;
	}
	if (url) {
		this.url = url;
	}
	jQuery(document).ready(function(){	
		jQuery(GENTICS.DragDrop.sortables).each(function() {
			try {
				jQuery("#" + this.id).sortable( "destroy" );
			} catch (ex) {
			}
		});
		jQuery(GENTICS.DragDrop.sortables).each(function() {
			jQuery("#" + this.id).sortable({
				connectWith:  this.connectWith,
				handle: this.handle,
				placeholder: this.helperclass,
				items: this.accept,
				opacity: 0.8,
				position: this.position,
				forcePlaceholderSize: true,
				dropOnEmpty: true,
				update: function(e, ui) {
					GENTICS.DragDrop.updatePositions();
				}
			});
		});
	});
}

/**
 * update sorted portlet positions with the server
 * all positions will be updated on every single sort action
 */
GENTICS.DragDrop.updatePositions = function() {
	var data = {
		"gentics.rl" : "true",
		positions: []
	};
	jQuery(this.sortables).each(function() {
		var ids = jQuery("#" + this.id).sortable("toArray");
		for(id in ids) {
			ids[id] = ids[id].replace(/.*_/g, "");
		}
		data.positions.push(this.position);
		data[this.position] = ids;
	});
	this.updatePosition(data);
}

/**
 * sends the updated positions to the server 
 */
GENTICS.DragDrop.updatePosition = function(data) {
	jQuery.post(this.url, data, function(cbdata) {
		cbdata = eval("(" + cbdata + ")");
		GENTICS.processResult(cbdata);
	});
}
